﻿package com.Tutorial 
{
    import com.adamatomic.flixel.*;
	import flash.geom.Rectangle;
	
	/**
	 * ...
	 * @author Stephen Lavelle
	 */
	public class WalkState extends FlxState
	{
	    [Embed(source = '../../data/levels/baccarat.txt', mimeType = "application/octet-stream")] private var BaccaratRoom:Class;
	    [Embed(source = '../../data/levels/blackjack.txt', mimeType = "application/octet-stream")] private var Blackjackroom:Class;
	    [Embed(source = '../../data/levels/craps.txt', mimeType = "application/octet-stream")] private var CrapRoom:Class;
		[Embed(source = '../../data/levels/keno.txt', mimeType = "application/octet-stream")] private var KenoRoom:Class;
		[Embed(source = '../../data/levels/mahj.txt', mimeType = "application/octet-stream")] private var MahjonggRoom:Class;		
	    [Embed(source = '../../data/levels/poker.txt', mimeType = "application/octet-stream")] private var PokerRoom:Class;
	    [Embed(source = '../../data/levels/pontoon.txt', mimeType = "application/octet-stream")] private var PontoonRoom:Class;
	    [Embed(source = '../../data/levels/roulette.txt', mimeType = "application/octet-stream")] private var RouletteRoom:Class;
	    [Embed(source = '../../data/levels/slots.txt', mimeType = "application/octet-stream")] private var SlotsRoom:Class;
	    [Embed(source = '../../data/levels/mainroom.txt', mimeType = "application/octet-stream")] private var MainRoom:Class;
		
	    [Embed(source = '../../data/gfx/floortiles.png')] private var GfxTiles:Class;
	    [Embed(source = '../../data/gfx/inspectframe.png')] private var GfxInspectFrame:Class;
		[Embed(source = '../../data/gfx/talkframe.png')] private var GfxTalkFrame:Class;
		
		private var _talkFrameBG:FlxSprite;
		private var _talkFramePicture:NPC;
		private var _talkFrameName:FlxText;
		private var _talkFrameText:FlxText;
		
		private var _inspectFrameBG:FlxSprite;
		private var _inspectFramePicture:NPC;
		private var _inspectFrameName:FlxText;
		private var _inspectFrameText:FlxText;
		
		private var _statusblock:FlxSprite;
		private var _levelText:FlxText;
		private var _convindex:int;
		
		private var _inspectselected:int;
		
		public var arNPCs:FlxArray;
		
        public static var lyrBG:FlxLayer;
		public static var lyrNPC:FlxLayer;
		public static var lyrPlayer:FlxLayer;
		public static var lyrHUD:FlxLayer;
		public static var lyrTalk:FlxLayer;
		public static var lyrInspect:FlxLayer;
		
		public static var fromMenu:Boolean;
		public static var px:Number;
		public static var py:Number;
		public static var pdir:Number;
		
		public static var toInspect:int;
		
		private var _curnpc:NPC;
		private var _map:FlxTilemap;
		
		private var _player:Player;
		
		private var _canspeakto:int;
		
		private var _overlapfound:Boolean;
		
		private var _levelDescr:String;

		private var interactionstate:int;//0 normal, 1 menu, 2 talk
		
		public function WalkState() 
		{
		
			_canspeakto = -1;	
			interactionstate = 0;
			
			lyrBG = new FlxLayer;
			lyrNPC = new FlxLayer;
			lyrPlayer = new FlxLayer;
			lyrHUD = new FlxLayer;
			lyrTalk = new FlxLayer;		
			lyrInspect = new FlxLayer;		
		
			
			if (!fromMenu)
			{
				if (FlxG.level != 9 )
				{			
					var startingPoints:Array;
					startingPoints = new Array();
					startingPoints = [
						[1, 2, "right"], 
						[8,5, "left"], 
						[2,1, "down"], 
						[2,6, "up"], 
						[7,1, "down"], 
						[4,6, "up"], 
						[1,5, "right"], 
						[8,2, "left"], 
						[7,6, "up"]
						];
								
					_player = new Player(startingPoints[FlxG.level][0]*16, startingPoints[FlxG.level][1]*16,startingPoints[FlxG.level][2]);
				}
				else
				{
					var hallwayPoints:Array;
					hallwayPoints = new Array();
					hallwayPoints = [
					[8, 5, "left"], 
					[1,2, "right"], 
					[7,6, "up"], 
					[7,1, "down"], 
					[2,6, "up"], 
					[4,1, "down"], 
					[8,2, "left"], 
					[1,5, "right"], 
					[2, 1, "down"],
					[4,6, "up"]
					];
					
					_player = new Player(hallwayPoints[FlxG.oldlevel][0]*16, hallwayPoints[FlxG.oldlevel][1]*16,hallwayPoints[FlxG.oldlevel][2]);
					
				}
			}
			else
			{
				var str:String;
				str = new String();
				
				switch(pdir)
				{
					case 0:
						str = "up";
						break;
					case 1:
						str = "down";
						break;
					case 2:
						str = "left";
						break;
					case 3:
						str = "right";
						break;
				}
				_player = new Player(px, py,str);
			}
			lyrPlayer.add(_player);
			_player.update();
			lyrPlayer.update();
			
			var NPCs:Array;
			NPCs = new Array();
			NPCs = [ 
						[ //baccarat 2
							[5, [4, 4] ],
							[10, [5, 4] ] 
						],
						[ //blackjack 1
							[18, [4, 4] ],
						],
						[ //crapsroom 1
							[31, [5, 2] ],
						],
						[ //kenoroom 3
							[0, [1, 5] ],
							[1, [6, 2] ],
							[27, [3, 2] ] 
						],
						[ //mahjonggroom 4
							[24, [2, 2] ], 
							[16, [4, 2] ], 
							[17, [3, 1] ], 
							[28, [3, 3] ]
						],
						[ //pokerroom 7
							[14, [3, 2] ], 
							[29, [4, 2] ], 
							[22, [6, 3] ], 
							[30, [6, 4] ], 
							[25, [2, 4] ], 
							[26, [3, 5] ], 
							[13, [4, 5] ] 
						],
						[ //pontoonroom 3
							[3, [6, 3] ], 
							[8, [4, 4] ], 
							[21, [5, 4] ] 
						],
						[ //rouletteroom 4
							[20, [6, 2] ], 
							[6, [5, 2] ] ,
							[7, [5, 5] ] ,
							[19, [6, 5] ] 
						],
						[ //slotsroom 7
							[2, [2, 2] ] ,
							[4, [2, 4] ] ,
							[11, [4, 2] ] ,
							[23, [5, 2] ] ,
							[12, [5, 5] ] ,
							[15, [7, 2] ] 
						],
						[ //mainroom HATMANONLY
							[32, [5, 3] ] 
						]
					];
					
			arNPCs = new FlxArray();
			
			for (var i:int = 0; i < NPCs[FlxG.level].length; i++)
			{
				arNPCs.push(new NPC(NPCs[FlxG.level][i][1][0]*16, NPCs[FlxG.level][i][1][1]*16, NPCs[FlxG.level][i][0]) );
				lyrNPC.add(arNPCs[arNPCs.length - 1]);
			}
			
			_talkFrameBG = new FlxSprite(GfxTalkFrame, 37, 24);
			lyrTalk.add(_talkFrameBG);
			_talkFramePicture = new NPC(42, 29, 0);
			lyrTalk.add(_talkFramePicture);
			_talkFrameName = new FlxText(60, 30, 100, 8, "BLAH", 0xff8d431f);
			lyrTalk.add(_talkFrameName);
			_talkFrameText = new FlxText(43, 50, 83, 100, "BLAH do dop doa", 0xff8d431f);
			_talkFrameText.setText("BLAH do dop doa adawe ", true);
			lyrTalk.add(_talkFrameText);			
			lyrTalk.visible = false;
			
			_inspectFrameBG = new FlxSprite(GfxInspectFrame, 38, 37);
			lyrInspect.add(_inspectFrameBG);
			_inspectFramePicture = new NPC(45, 57, 0);
			lyrInspect.add(_inspectFramePicture);
			_inspectFrameName = new FlxText(46, 38, 100, 8, "BLAH", 0xff8d431f);
			lyrInspect.add(_inspectFrameName);
			_inspectFrameText = new FlxText(69, 50, 100, 100, " BLAH\n>blah\n blah", 0xff8d431f);
			lyrInspect.add(_inspectFrameText);			
			lyrInspect.visible = false;
			
			_levelDescr = new String;
				
			switch(FlxG.level)
			{
				case 0:
					_map = new FlxTilemap(new BaccaratRoom , GfxTiles, 8 );
					_levelDescr = "Baccarat Room";
				break;
				case 1:
					_map = new FlxTilemap(new Blackjackroom , GfxTiles, 8 );
					_levelDescr = "Black Jack Room";
				break;
				case 2:
					_map = new FlxTilemap(new CrapRoom , GfxTiles, 8 );
					_levelDescr = "Craps Room";
				break;
				case 3:
					_map = new FlxTilemap(new KenoRoom , GfxTiles, 8 );
					_levelDescr = "Keno Room";
				break;
				case 4:
					_map = new FlxTilemap(new MahjonggRoom , GfxTiles, 8 );
					_levelDescr = "Mahjong Room";
				break;
				case 5:
					_map = new FlxTilemap(new PokerRoom , GfxTiles, 8 );
					_levelDescr = "Poker Room";
				break;
				case 6:
					_map = new FlxTilemap(new PontoonRoom , GfxTiles, 8 );
					_levelDescr = "Pontoon Room";
				break;
				case 7:
					_map = new FlxTilemap(new RouletteRoom , GfxTiles, 8 );
					_levelDescr = "Roulette Room";
				break;
				case 8:
					_map = new FlxTilemap(new SlotsRoom , GfxTiles, 8 );
					_levelDescr = "Slots Room";
				break;
				case 9:
					_map = new FlxTilemap(new MainRoom , GfxTiles, 8 );
					_levelDescr = "Foyer";
				break;					
			}	
				
			lyrBG.add(_map);
			
			_statusblock = new FlxSprite(null, 0, 128, false, false, FlxG.width, 16, 0xff8d431f);
			
			lyrHUD.add(_statusblock);
			
			_levelText = new FlxText(16, 129, 200, 8, _levelDescr, 0xfff36f36,null,8);
			lyrHUD.add(_levelText);
			lyrHUD.add( new FlxText(0, 129, FlxG.width, 8,BattleState.dieCount+"/32 ("+BattleState.matchCount+")", 0xfff36f36,null,8,"right"));
			this.add(lyrBG);
			this.add(lyrNPC);
			this.add(lyrPlayer);
			this.add(lyrHUD);
			this.add(lyrTalk);
			this.add(lyrInspect);
			
			if (InspectState.showInteract)
			{
				InspectState.showInteract = false;
				_curnpc = new NPC(0, 0, toInspect);
				interactionMenu();
			}
			else if (ChooseDieState.showInteract)
			{
				ChooseDieState.showInteract = false;
				_curnpc = new NPC(0, 0, toInspect);
				interactionMenu();
				if (FlxG.hasdie[_curnpc.npcIndex])
				{
					_inspectselected = 0;
				}
				else
				{
					_inspectselected = 2;
				}
				_inspectFrameText.setText(getmenutext(),true);		
			}
			
		}
		
		override public function update():void
        {
			super.update();
			switch (interactionstate)
			{
				case 0:
					normalUpdate();
					break;
				case 1:
					interactionUpdate();
					break;
				case 2:
					talktoUpdate();
					break;
			}
		}
		
		public function normalUpdate():void
		{
			_map.collide(_player);
			FlxG.collideArray(arNPCs, _player);
			
			var cacheX:Number = _player.x;
			var cacheY:Number = _player.y;
			
			switch (_player.direction)
			{
				case 0:
					_player.y -= 10;
					break;
				case 1:
					_player.y += 10;
					break;
				case 2:
					_player.x -= 10;
					break;
				case 3:
					_player.x += 10;
					break;
			}
			_overlapfound = false;
			_canspeakto = -1;
			FlxG.overlapArray(arNPCs, _player, nearNPC);
			if (!_overlapfound)
				_levelText.setText(_levelDescr);
			_player.x = cacheX;
			_player.y = cacheY;
			
			if (_canspeakto >= 0)
			{
				if (FlxG.justPressed(FlxG.A))
				{
					_player.stop();
					if (_canspeakto == 32)
					{
						talkToPerson();
					}
					else
					{
						interactionMenu();
					}
				}
			}
			if (FlxG.justPressed(FlxG.B))
			{				
				ChooseDieState.inventory = true;
				savestate();
				FlxG.switchState(ChooseDieState);
			}
		}
		
		public function interactionUpdate():void
		{
			if (FlxG.justPressed(FlxG.UP))
			{
				if ( FlxG.hasdie[_curnpc.npcIndex])
					_inspectselected = (_inspectselected + 1) % 2;
				else
					_inspectselected = (_inspectselected + 2) % 3;
				
				_inspectFrameText.setText(getmenutext(),true);		
				_inspectFrameText.update();
			}
			if (FlxG.justPressed(FlxG.DOWN))
			{				
				if ( FlxG.hasdie[_curnpc.npcIndex])
					_inspectselected = (_inspectselected + 1) % 2;
				else
					_inspectselected = (_inspectselected + 1) % 3;
					
	
				_inspectFrameText.setText(getmenutext(),true);		
				_inspectFrameText.update();
				
			}
			
			if (FlxG.justPressed(FlxG.A))
			{
				switch(_inspectselected)
				{
					case 0:
						toInspect = _curnpc.npcIndex;
						savestate();
						FlxG.switchState(InspectState);
					break;
					case 1:
						talkToPerson();
					break;
						savestate();
					case 2:
						toInspect = _curnpc.npcIndex;
						ChooseDieState.inventory = false;
						savestate();
						FlxG.switchState(ChooseDieState);
					break;
				}
			}
			if  (FlxG.justPressed(FlxG.B))
			{
				closeMenus();				
			}
		}
		
		public function talktoUpdate():void
		{
			if (FlxG.justPressed(FlxG.A))
			{
				_convindex++;
				if (_convindex >= _curnpc.conv.length)
				{
					if (_curnpc.npcIndex != 32)
					{
						interactionMenu();
						_inspectselected = 1;
						_inspectFrameText.setText(getmenutext(),true);		
					}
					else
					{
						closeMenus();
					}
				}
				else
				{			
					_talkFrameText.setText(_curnpc.conv[_convindex],true);					
				}
			}
			if (FlxG.justPressed(FlxG.B))
			{
				closeMenus();
			}
		}
		
		public function getmenutext():String
		{
			var s:String;
			s = new String;

			if (_inspectselected == 0)
				s += ">";
			else
				s += " ";
			s += "Inspect\n";
			
			if (_inspectselected == 1)
				s += ">";
			else
				s += " ";
			s += "Talk\n";
				
			if (!FlxG.hasdie[_curnpc.npcIndex])
			{
				if (_inspectselected == 2)
					s += ">";
				else
					s += " ";
				s += "Challenge\n";
			}
				
			return s;
		}
		
		public function closeMenus():void
		{
			interactionstate = 0;
			lyrInspect.visible = false;
			lyrTalk.visible = false;
			_player.start();
		}
		public function interactionMenu():void
		{
			_player.stop();
			
			interactionstate = 1;
			_levelText.setText(_levelDescr);
			
			_inspectselected = 0;
									
			lyrInspect.visible = true;
			lyrTalk.visible = false;
			
			_inspectFrameName.setText(_curnpc.ownername);
			
			_inspectFramePicture.changeframe(_curnpc.npcIndex);
			_inspectFrameText.setText(getmenutext(),true);
			
			_inspectFramePicture.update();
			_inspectFrameBG.update();
			_inspectFrameName.update();
			_inspectFrameText.update();
			
			lyrInspect.update();	
		}
		
		public function talkToPerson():void
		{
			
			_player.stop();

			interactionstate = 2;
			_levelText.setText(_levelDescr);
			
			lyrInspect.visible = false;
			lyrTalk.visible = true;
			_talkFrameName.setText(_curnpc.ownername);
			_convindex = 0;
			_talkFramePicture.changeframe(_curnpc.npcIndex);
			_talkFrameText.setText(_curnpc.conv[_convindex],true);
			
			_talkFramePicture.update();
			_talkFrameBG.update();
			_talkFrameName.update();
			_talkFrameText.update();
			lyrTalk.update();			
		}
		
		
		public function nearNPC(npc:NPC, p:Player):void
		{
			_curnpc = npc;
			_overlapfound = true;
			_canspeakto = npc.npcIndex;
			_levelText.setText(npc.ownername);
		}
		
		public function savestate():void
		{
			fromMenu = true;
			px = _player.x;
			py = _player.y;
			pdir = _player.direction;
		}
	}

}